//+------------------------------------------------------------------+
//|                                            MTF_MovingAverage.mq4 |
//|                                      Copyright  2006, Keris2112 |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "Copyright  2006, Keris2112"
#property link      "http://www.forex-tsd.com"

#property indicator_separate_window
#property indicator_buffers 2
#property indicator_color1 Gold
#property indicator_color2 Red
#property indicator_width1 2
#property indicator_width2 2

//---- input parameters
/*************************************************************************
PERIOD_M1   1
PERIOD_M5   5
PERIOD_M15  15
PERIOD_M30  30 
PERIOD_H1   60
PERIOD_H4   240
PERIOD_D1   1440
PERIOD_W1   10080
PERIOD_MN1  43200
You must use the numeric value of the timeframe that you want to use
when you set the TimeFrame' value with the indicator inputs.
---------------------------------------
PRICE_CLOSE    0 Close price. 
PRICE_OPEN     1 Open price. 
PRICE_HIGH     2 High price. 
PRICE_LOW      3 Low price. 
PRICE_MEDIAN   4 Median price, (high+low)/2. 
PRICE_TYPICAL  5 Typical price, (high+low+close)/3. 
PRICE_WEIGHTED 6 Weighted close price, (high+low+close+close)/4. 
You must use the numeric value of the Applied Price that you want to use
when you set the 'applied_price' value with the indicator inputs.
---------------------------------------
MODE_SMA    0 Simple moving average, 
MODE_EMA    1 Exponential moving average, 
MODE_SMMA   2 Smoothed moving average, 
MODE_LWMA   3 Linear weighted moving average. 
You must use the numeric value of the MA Method that you want to use
when you set the 'ma_method' value with the indicator inputs.

**************************************************************************/
extern int TimeFrame          = 0;
extern int MAPeriod           = 1;
extern int ma_shift           = 0;
extern int ma_method          = 1;
extern int applied_price      = 4;
extern bool arrows            = true;
extern bool Alertss           = true;
//---- buffers
string sPrefix;

double ExtMapBuffer1[];
double ExtMapBuffer2[];
int b=0,s=0;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   string short_name;
//---- indicator line
   SetIndexBuffer(0,ExtMapBuffer1);
   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(1,ExtMapBuffer2);
   SetIndexStyle(1,DRAW_LINE);
   if(TimeFrame==0) TimeFrame = Period();
   SetIndexShift(0,ma_shift*TimeFrame/Period());
//---- name for DataWindow and indicator subwindow label   
   switch(ma_method)
     {
      case 1 : short_name="MTF_EMA("; break;
      case 2 : short_name="MTF_SMMA("; break;
      case 3 : short_name="MTF_LWMA("; break;
      default : short_name="MTF_SMA(";
     }
   switch(TimeFrame)
   {
      case 1 : string TimeFrameStr="Period_M1"; break;
      case 5 : TimeFrameStr="Period_M5"; break;
      case 15 : TimeFrameStr="Period_M15"; break;
      case 30 : TimeFrameStr="Period_M30"; break;
      case 60 : TimeFrameStr="Period_H1"; break;
      case 240 : TimeFrameStr="Period_H4"; break;
      case 1440 : TimeFrameStr="Period_D1"; break;
      case 10080 : TimeFrameStr="Period_W1"; break;
      case 43200 : TimeFrameStr="Period_MN1"; break;
      default : TimeFrameStr="Current Timeframe";
   } 
   sPrefix ="Grail Indicator";
IndicatorShortName(sPrefix) ;  
  
//----
   return(0);}
   int deinit()
  {
DelOb();
   return(0);
  }
 
//+------------------------------------------------------------------+
//| MTF Moving Average                                   |
//+------------------------------------------------------------------+
int start()
  {
   datetime TimeArray[];
   int    i,shift,limit,y=0,counted_bars=IndicatorCounted();
   
// Plot defined timeframe on to current timeframe   
   ArrayCopySeries(TimeArray,MODE_TIME,Symbol(),TimeFrame); 
   
   limit=Bars-counted_bars+TimeFrame/Period();
   //limit=Bars-counted_bars;  bad
   for(i=0,y=0;i<limit;i++)
   {
   if (Time[i]<TimeArray[y]) y++; 
   
 /***********************************************************   
   Add your main indicator loop below.  You can reference an existing
      indicator with its iName  or iCustom.
   Rule 1:  Add extern inputs above for all neccesary values   
   Rule 2:  Use 'TimeFrame' for the indicator timeframe
   Rule 3:  Use 'y' for the indicator's shift value
 **********************************************************/  
    
   ExtMapBuffer1[i]=iCustom(NULL,TimeFrame,"BtTrendTrigger-T-Signal",1,y) ;
   ExtMapBuffer2[i]=iCustom(NULL,TimeFrame,"Essam00",1,y); 
   
   }  
     
//
   
  
  for(int e=0; e < Bars; e++)
  { 
      if(arrows)
      {
        if(ExtMapBuffer1[e]>=ExtMapBuffer2[e] && ExtMapBuffer1[e+1]<ExtMapBuffer2[e+1])
        {
        DrawAr("up",e);
        }
        if(ExtMapBuffer1[e]<=ExtMapBuffer2[e] && ExtMapBuffer1[e+1]>ExtMapBuffer2[e+1])
        {
        DrawAr("dn",e);
        }      
       }
   }
   if(Alertss){Alerts();}      
   return(0);
}

void DelOb()
{
    int n = ObjectsTotal();
    for (int i = n - 1; i >= 0; i--) 
    {
     string sName = ObjectName(i);
	  if (StringFind(sName, sPrefix) == 0) 
	  {
	    ObjectDelete(sName);
	  }
    }
}

//----------------------------------------------------------------------
void DrawAr(string ssName, int i)
{
    
    string sName=sPrefix+" "+ssName+" "+ TimeToStr(Time[i],TIME_DATE|TIME_MINUTES);
    ObjectDelete(sName);    
    ObjectCreate(sName, OBJ_ARROW, 0, Time[i], 0);
    double gap  = 3.0*iATR(NULL,0,10,i)/4.0;
    if(ssName=="dn")
    {
    ObjectSet(sName, OBJPROP_ARROWCODE,  233);
    ObjectSet(sName, OBJPROP_PRICE1, Low[i]-0*Point);
    ObjectSet(sName, OBJPROP_COLOR, Blue);
    }
    if(ssName=="up")
    {
    ObjectSet(sName, OBJPROP_ARROWCODE,  234);
    ObjectSet(sName, OBJPROP_PRICE1, High[i]+0*Point);
    ObjectSet(sName, OBJPROP_COLOR, Red);    
    }    
    ObjectSet(sName, OBJPROP_WIDTH, 1);
} 
//Alert****************************************************************
void Alerts(){
   if(ExtMapBuffer1[0]>=ExtMapBuffer2[0] && ExtMapBuffer1[1]<ExtMapBuffer2[1] && b==0){
      Alert("!");
      b=1;
      s=0;
   }
   if(ExtMapBuffer1[0]<=ExtMapBuffer2[0] && ExtMapBuffer1[1]>ExtMapBuffer2[1] && s==0){
      Alert("!");
      b=0;
      s=1; 
   }
}                  
                   
                    
          
   
   
  
  

